unit OEMUtils;
 // Проблемы с кириллицей  - UTF8
 //     - Win1251
 // changes for use under UTF-8
 // font "-misc-fixed-medium-r-semicondensed-*-*-*-*-*-c-*-koi8-r"
 //   or "-misc-fixed-medium-r-semicondensed-*-*-*-*-*-c-*-iso10646-*"
interface

uses Types;
type
  Char3 = String[3];
  DEC_table = array [#128..#255] of char;
  UTF_table = array [#128..#255] of Char3;

  BOOL = LongBool;
const
{$IFDEF LINUX}
{.$DEFINE KOI8}
{$DEFINE UTF8}
{$ENDIF}

{$IFDEF KOI8}
     DOS2WIN: DEC_table = (      { Alt -> KOI8 }
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','.','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','?','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ');

     Win2DOS: DEC_table=  { -8   - koi8 }
     ('','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','?','','','','');
{$ELSE}
{$IFDEF ASC_CODE}
    DOS2WIN: DEC_table =
    (
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '-','-','-','|','-','|','|','|','=','=','=','=','|','=','|','=',
    '-','=','-','-','=','=','-','|','|','-','-','X','x','|','|','^',
    '','','','','','','','','','','','','','','',#255,
    '','','','','','','','','','','','','','','',''
    );

    Win2DOS: DEC_table =
    (
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','?','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','',''
    );
{$ELSE} // digital
 DOS2WIN: DEC_Table =(
   #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,
   #208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,
   #224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,
   #176,#177,#178,#179,#180,#181,#182,#183,#184,#185,#186,#187,#188,#189,#190,#191,
    #45, #45, #45,#124, #45,#124,#124,#124, #61, #61, #61, #61,#124, #61,#124, #61,
    #45, #61, #45, #45, #61, #61, #45,#124,#124, #45, #45, #88,#120,#124,#124, #94,
   #240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255,
   #176,#177,#178,#179,#180,#181,#182,#183,#184,#185,#186,#187,#188,#189,#190,#191
  );
 WIN2DOS: DEC_Table =(
   #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,
   #208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,
   #176,#177,#178,#179,#180,#181,#182,#183,#184,#185,#186,#187,#188,#189,#190,#191,
   #240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255,
   #128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#138,#139,#140,#141,#142,#143,
   #144,#145,#146,#147,#148,#149,#150,#151, #63,#153,#154,#155,#156,#157,#158,#159,
   #160,#161,#162,#163,#164,#165,#166,#167,#168,#169,#170,#171,#172,#173,#174,#175,
   #224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239
  );
{$ENDIF}
{$ENDIF}

{$DEFINE UTF8}
{$IFDEF UTF8}
{$IFDEF ASC_CODE}
   DOS2UTF8: UTF_table =
   (
    'А','Б','В','Г','Д','Е','Ж','З','?','Й','К','Л','М','Н','О','П',
    'Р','С','Т','У','Ф','Х','Ц','Ч','Ш','Щ','Ъ','Ы','Ь','Э','Ю','Я',
    'а','б','в','г','д','е','ж','з','и','й','к','л','м','н','о','п',
    '°','±','І','і','ґ','µ','¶','·','ё','№','є','»','?','Ѕ','ѕ','ї',
    '-','-','-','|','-','|','|','|','=','=','=','=','|','=','|','=',
    '-','=','-','-','=','=','-','|','|','-','-','X','x','|','|','^',
    'р','с','т','у','ф','х','ц','ч','ш','щ','ъ','ы','ь','э','ю','я',
    '°','±','І','і','ґ','µ','¶','·','ё','№','є','»','?','Ѕ','ѕ','ї'
   );

      WIN_UTF8_T: UTF_Table=   { Заготовка таблицы - Alt_Alt_T }
   (
    'Ђ','Ѓ','‚','ѓ','„','…','†','‡','€','‰','Љ','‹','Њ','Ќ','Ћ','Џ',
    'ђ','‘','’','“','”','•','–','—','�','™','љ','›','њ','ќ','ћ','џ',
    ' ','Ў','ў','Ј','¤','Ґ','¦','§','Ё','©','Є','«','¬','­','®','Ї',
    '°','±','І','і','ґ','µ','¶','·','ё','№','є','»','ј','Ѕ','ѕ','ї',
    'А','Б','В','Г','Д','Е','Ж','З','И','Й','К','Л','М','Н','О','П',
    'Р','С','Т','У','Ф','Х','Ц','Ч','Ш','Щ','Ъ','Ы','Ь','Э','Ю','Я',
    'а','б','в','г','д','е','ж','з','и','й','к','л','м','н','о','п',
    'р','с','т','у','ф','х','ц','ч','ш','щ','ъ','ы','ь','э','ю','я'
    );
    
    DOS2utf8: UTF_table =
(
'А','Б','В','Г','Д','Е','Ж','З','?','Й','К','Л','М','Н','О','П',
'Р','С','Т','У','Ф','Х','Ц','Ч','Ш','Щ','Ъ','Ы','Ь','Э','Ю','Я',
'°','±','І','і','ґ','µ','¶','·','ё','№','є','»','?','Ѕ','ѕ','ї',
'р','с','т','у','ф','х','ц','ч','ш','щ','ъ','ы','ь','э','ю','я',
'.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
'.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
{
'.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.',
'.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.'
}
' ','Ў','ў','Ј','¤','Ґ','¦','§','Ё','©','Є','«','¬','­','®','Ї',
'а','б','в','г','д','е','ж','з','и','й','к','л','м','н','о','п'
);
{$ELSE} // digital
 WIN_UTF8_T: UTF_Table =(
      #208#130,   #208#131,#226#128#154,   #209#147,#226#128#158,#226#128#166,#226#128#160,#226#128#161,
   #226#130#172,#226#128#176,   #208#137,#226#128#185,   #208#138,   #208#140,   #208#139,   #208#143,
      #209#146,#226#128#152,#226#128#153,#226#128#156,#226#128#157,#226#128#162,#226#128#147,#226#128#148,
   #239#191#189,#226#132#162,   #209#153,#226#128#186,   #209#154,   #209#156,   #209#155,   #209#159,
      #194#160,   #208#142,   #209#158,   #208#136,   #194#164,   #210#144,   #194#166,   #194#167,
      #208#129,   #194#169,   #208#132,   #194#171,   #194#172,   #194#173,   #194#174,   #208#135,
      #194#176,   #194#177,   #208#134,   #209#150,   #210#145,   #194#181,   #194#182,   #194#183,
      #209#145,#226#132#150,   #209#148,   #194#187,   #209#152,   #208#133,   #209#149,   #209#151,
      #208#144,   #208#145,   #208#146,   #208#147,   #208#148,   #208#149,   #208#150,   #208#151,
      #208#152,   #208#153,   #208#154,   #208#155,   #208#156,   #208#157,   #208#158,   #208#159,
      #208#160,   #208#161,   #208#162,   #208#163,   #208#164,   #208#165,   #208#166,   #208#167,
      #208#168,   #208#169,   #208#170,   #208#171,   #208#172,   #208#173,   #208#174,   #208#175,
      #208#176,   #208#177,   #208#178,   #208#179,   #208#180,   #208#181,   #208#182,   #208#183,
      #208#184,   #208#185,   #208#186,   #208#187,   #208#188,   #208#189,   #208#190,   #208#191,
      #209#128,   #209#129,   #209#130,   #209#131,   #209#132,   #209#133,   #209#134,   #209#135,
      #209#136,   #209#137,   #209#138,   #209#139,   #209#140,   #209#141,   #209#142,   #209#143
  );
     DOS2UTF8: UTF_table = (
      #208#144,   #208#145,   #208#146,   #208#147,   #208#148,   #208#149,   #208#150,   #208#151,
      #208#152,   #208#153,   #208#154,   #208#155,   #208#156,   #208#157,   #208#158,   #208#159,
      #208#160,   #208#161,   #208#162,   #208#163,   #208#164,   #208#165,   #208#166,   #208#167,
      #208#168,   #208#169,   #208#170,   #208#171,   #208#172,   #208#173,   #208#174,   #208#175,
      #208#176,   #208#177,   #208#178,   #208#179,   #208#180,   #208#181,   #208#182,   #208#183,
      #208#184,   #208#185,   #208#186,   #208#187,   #208#188,   #208#189,   #208#190,   #208#191,
      #194#176,   #194#177,   #208#134,   #209#150,   #210#145,   #194#181,   #194#182,   #194#183,
      #209#145,#226#132#150,   #209#148,   #194#187,   #209#152,   #208#133,   #209#149,   #209#151,
      #45,   #45,   #45,   #124,   #45,   #124,   #124,   #124,
      #61,   #61,   #61,   #61,   #124,   #61,   #124,   #61,
      #45,   #61,   #45,   #45,   #61,   #61,   #45,   #124,
      #124,   #45,   #45,   #88,   #120,   #124,   #124,   #94,
      #209#128,   #209#129,   #209#130,   #209#131,   #209#132,   #209#133,   #209#134,   #209#135,
      #209#136,   #209#137,   #209#138,   #209#139,   #209#140,   #209#141,   #209#142,   #209#143,
      #194#176,   #194#177,   #208#134,   #209#150,   #210#145,   #194#181,   #194#182,   #194#183,
      #209#145,#226#132#150,   #209#148,   #194#187,   #209#152,   #208#133,   #209#149,   #209#151
      );

{$ENDIF}
{$ENDIF}

(*
Convert decode tables
    Alt_Alt_T: CodTable=   { Заготовка таблицы - Alt_Alt_T }
   (
    'Ђ','Ѓ','‚','ѓ','„','…','†','‡','€','‰','Љ','‹','Њ','Ќ','Ћ','Џ',
    'ђ','‘','’','“','”','•','–','—','','™','љ','›','њ','ќ','ћ','џ',
    ' ','Ў','ў','Ј','¤','Ґ','¦','§','Ё','©','Є','«','¬','­','®','Ї',
    '°','±','І','і','ґ','µ','¶','·','ё','№','є','»','ј','Ѕ','ѕ','ї',
    'А','Б','В','Г','Д','Е','Ж','З','И','Й','К','Л','М','Н','О','П',
    'Р','С','Т','У','Ф','Х','Ц','Ч','Ш','Щ','Ъ','Ы','Ь','Э','Ю','Я',
    'а','б','в','г','д','е','ж','з','и','й','к','л','м','н','о','п',
    'р','с','т','у','ф','х','ц','ч','ш','щ','ъ','ы','ь','э','ю','я'
    );
      Alt_Alt_L: LatTable=   { Заготовка таблицы с лат. буквами }
   (
   '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
   'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_',
   '`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
   'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',''
   );



    Alt_UTF8_T: CodTable=   {   - Alt_Alt_T }
   (
    '-','-','-','|','-','|','|','|','=','=','=','=','|','=','|','=',
    '-','=','-','-','=','=','-','|','|','-','-','X','x','|','|','^',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','',#255
    );
      Alt_Alt_L: LatTable=   {    .  }
   (
   '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
   'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_',
   '`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
   'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',''
   );


Alt_Alt_T: CodTable=   {   - Alt_Alt_T }
    (
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','','',
    '','','','','','','','','','','','','','','',''
    );  
	
    Alt_Alt_L: LatTable=   {   ? ???. ??????? }
   (
   '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
   'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_',
   '`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
   'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',''
   );

*)
function OemToCharBuff(lpszSrc: PChar; lpszDst: PChar; cchDstLength: DWORD): BOOL;
function CharToOemBuff(lpszSrc: PChar; lpszDst: PChar; cchDstLength: DWORD): BOOL;

implementation

(*
function UTF2Win(P:PChar) : PChar;
  {  }
 var
      Nxt, pCh  : PChar;
      i, Len: integer;
  begin { UTF2Win }
    Result:=P;
    Nxt  := P;
    pCh  := P;
    Len :=  lStrLen(P);
    while Nxt < P + Len do
    begin
       if (Nxt[0]<#128) then
       begin
          if pCh<>Nxt then pCh[0]:=Nxt[0];
       end else
       if (Nxt[0]=#$d0) then // or(Nxt[0]=#$d1)
       begin // 208..209 good cyr UTF   � -�
          Nxt := CharNext(Nxt);
          pCh[0] := char(byte(Nxt[0])+48);
          {
          if Nxt[0]<#128
           then pCh[0] := char(byte(Nxt[0])+112)
           else pCh[0] := char(byte(Nxt[0])+48);
          }
       end else
       if Nxt[0]=#$d1 then
       begin // 208..209 good cyr UTF �-�
          Nxt := CharNext(Nxt);
          pCh[0] := char(byte(Nxt[0])+112);
       end else
       if (Nxt[0]=#195) or (Nxt[0]=#196) then
       begin  // bad cyr letter
          Nxt := CharNext(Nxt);
          pCh[0] := char(byte(Nxt[0])+64);
       end else
       begin  // bad cyr letter
          Nxt := CharNext(Nxt);
          pCh[0] := char(byte(Nxt[0])+64);
       end;
{
       if B=$d0 then
       begin  // 208..209 good cyr UTF
        inc(i); if i<Len then Bn:=pB^[i] else Bn:=32;
        S := S+ char(Bn+48);
       end else
       if B=$d1 then
       begin  // 208..209 good cyr UTF
        inc(i); if i<Len then Bn:=pB^[i] else Bn:=32;
        S := S+ char(Bn+112);
       end else
       if (B=195)or(B=196) then
       begin // bad cyr letter
         inc(i); if i<Len then Bn:=pB^[i] else Bn:=32;
         S := S+chr(Bn+64);
       end else
       begin
         if Ch>' ' then S:=S+Ch else S:=S+' ';
         inc(i); if i<Len then Bn:=pB^[i] else Bn:=32;
         S := S+chr(Bn+64);
       end;
}
       Nxt := CharNext(Nxt);
       pCh := CharNext(pCh);
    end;
    pCh[0]:=#0;
  end { UTF2Win };
*)
function UTF2Win(P:PChar) : integer;
  { convert UTF8 string to win1251 and return new length }
 var
     Nxt, pCh  : PChar;
     i, Len: integer;

function CharNext(p: pChar): pChar;
begin
  Result := p+1;
end;
begin { UTF2Win }
  Result:=0;
  Nxt  := P;
  pCh  := P;
  Len :=  StrLen(P);
  while Nxt < P + Len do
  begin
     if (Nxt[0]<#128) then
     begin
        if pCh<>Nxt then pCh[0]:=Nxt[0];
     end else
     if (Nxt[0]=#$d0) then // or(Nxt[0]=#$d1)
     begin // 208..209 good cyr UTF   � -�
        Nxt := CharNext(Nxt);
        pCh[0] := char(byte(Nxt[0])+48);
        {
        if Nxt[0]<#128
         then pCh[0] := char(byte(Nxt[0])+112)
         else pCh[0] := char(byte(Nxt[0])+48);
        }
     end else
     if Nxt[0]=#$d1 then
     begin // 208..209 good cyr UTF �-�
        Nxt := CharNext(Nxt);
        pCh[0] := char(byte(Nxt[0])+112);
     end else
     if (Nxt[0]=#195) or (Nxt[0]=#196) then
     begin  // bad cyr letter
        Nxt := CharNext(Nxt);
        pCh[0] := char(byte(Nxt[0])+64);
     end else
     begin  // bad cyr letter
        Nxt := CharNext(Nxt);
        pCh[0] := char(byte(Nxt[0])+64);
     end;
     Nxt := CharNext(Nxt);
     pCh := CharNext(pCh);
  end;
  pCh[0]:=#0;
  Result := pCh-p;
end { UTF2Win };


function OemToCharBuff(lpszSrc: PChar; lpszDst: PChar; cchDstLength: DWORD): BOOL;
var i,j: integer;
    c: char;
    c2: Char3;
{$IFDEF UTF8}
    b: array[0..1023] of char;
{$ENDIF}

begin
{$IFDEF UTF8}
   i:=0;
   j:=0;
   while i<cchDstLength do
   begin
      c:=lpszSrc[i];
    //  if c>=#128 then c:=DOS2Win[c];
      if c>#128 then c2:=DOS2UTF8[c] else C2:=c;
      b[j]:=c2[1];
      inc(i);
      inc(j);
      if Length(c2)>1 then
      begin b[j]:=c2[2];
        inc(j);
      end;
   end;
   for i:=0 to j-1 do lpszDst[i]:=b[i];
{$ELSE}
   for i := 0 to cchDstLength-1 do //with len
   begin
      c:=lpszSrc[i];
      if c>=#128 then c:=DOS2Win[c];
      lpszDst[i]:=c;
   end;
{$ENDIF}
{
  if lpszDst <> lpszSrc then
    StrLCopy(lpszDst, lpszSrc, cchDstLength);
}
  Result := TRUE;
end;

function CharToOemBuff(lpszSrc: PChar; lpszDst: PChar; cchDstLength: DWORD): BOOL;
var i, Len: integer;
    c: char;
    // S: String;
begin
{$IFDEF UTF8}
   {
   SetLength(S, cchDstLength);
   for i := 0 to cchDstLength-1 do  //
     S[i+1]:=  lpszSrc[i];
   }
   // UTF8ToAnsi is not working
   Len:=UTF2Win(lpszSrc);
   for i := 0 to Len-1 do //with len
   begin
     c:=lpszSrc[i];
     if c>=#128 then c:=Win2DOS[c];
     lpszDst[i]:=c;
   end;
   for i := Len to cchDstLength-1 do //with len
    lpszDst[i]:=' ';
{$ELSE}
   for i := 0 to cchDstLength-1 do //with len
   begin
      c:=lpszSrc[i];
      if c>=#128 then c:=Win2DOS[c];
      lpszDst[i]:=c;
   end;
{$ENDIF}
   {
  if lpszDst <> lpszSrc then
    StrLCopy(lpszDst, lpszSrc, cchDstLength);
   }
  Result := TRUE;
end;

end.
